#include <stdio.h>
#include "evstack.h"
#include "parsearg.h"

#ifdef MODULE

/* FIXME This is far too simple ! */

int sscanf(const char *string, const char *format,...)
{
	const char *old=string;
	int numfield=0;
	va_list args;
	
	va_start(args,format);
	
	while(*format)
	{	switch(*format)
		{
		  case ' ':
		  	while(*string==' ' || *string=='\t') string++;
		  	break;	/* skip whitespace */
		  case '%':	/* we have to get a field */
		   	switch(*++format)
			{
			  case 's':
			  	{ char *str=va_arg(args,char *);
			  	  while(*string==' ' || *string=='\t') string++;
			  	  while(*string!=' '  && 
			  	  	*string!='\t' &&
			  	  	*string!='\0' ) *str++=*string++;
			  	  *str++='\0';
			  	  numfield++;
			  	} break;
			  case 'x':
			  	{ int *val=va_arg(args,int *);
				  *val=0;
			  	  while(*string==' ' || *string=='\t') string++;
				  while(1) 
				  {
					  /**/ if (*string>='0'&&*string<='9') *val=(*val<<4)+(*string-'0');
					  else if (*string>='a'&&*string<='f') *val=(*val<<4)+(*string-'a'+10);
					  else if (*string>='A'&&*string<='F') *val=(*val<<4)+(*string-'A'+10);
					  else break;
					  string++;
				  }
			  	  numfield++;
			  	} break;
			  case 'd':	/* Fixme. Detect Sign ... */
			  	{ int *val=va_arg(args,int *);
				  *val=0;
			  	  while(*string==' ' || *string=='\t') string++;
				  while(1) 
				  {
					  /**/ if (*string>='0'&&*string<='9') *val=(*val*10)+(*string-'0');
					  else break;
					  string++;
				  }
			  	  numfield++;
			  	} break;
			  case 'n':
			  	{ int *rc=va_arg(args,int *);
			  	  *rc=string-old;
			  	} break;
			}
			break;
		}
		format++;
	}

	va_end(args);
	return numfield;	/* Fixme - implement this */
}
#endif

char    *par_stack_to_string(evstack *stack)
{ static char stk[50];
  sprintf(stk,"%08x",stack ? stack->id : 0);
  return stk;
}

evstack *par_string_to_stack(char *string)
{ int id;
  sscanf(string,"%x",&id);
  return (ev_lookup_stack(NULL,id));
}
