/* To abstract the evstack values from userspace, we have a few conversion-routines
 * here to be able to change the interface consistently within a single file which
 * is linked to the evstack module.
 * Please do _NOT_ use a representation which might cause problems, e.g. using simply 
 * %p and printf/scanf would be lethal, it someone gave you a wrong address.
 * For illegal values something like NULL or -1 should be returned.
 * Add functionality as needed.
 */

char    *par_stack_to_string(evstack *stack);
evstack *par_string_to_stack(char *string);
