#ifndef _debug_h_
#define _debug_h_

#include <stdio.h>
#include <stdarg.h>

extern int ggiDebugState;

#ifdef __GNUC__

void _DPRINT(const char *file,int line,const char *format,...);
#define DPRINT(form,args...)  _DPRINT(__FILE__,__LINE__,form, ##args)

#else

extern void DPRINT(const char *format,...);

#endif

#endif /* _debug_h_ */
